﻿#include "p16f18877.inc"
__CONFIG _CONFIG1, _FEXTOSC_HS & _RSTOSC_EXT1X
__CONFIG _CONFIG2, _BOREN_ON & _PPS1WAY_OFF
__CONFIG _CONFIG3, _WDTE_OFF 
__CONFIG _CONFIG5, _CP_OFF & _CPD_OFF
    
IDX		EQU	0X20	;00時要顯示個位數,FF時要顯示十位數
T1CNT		EQU	0X21	;初值5,每中斷1次即減1,減到0即為0.5秒
ONEIDX		EQU	0X22	;個位查表指標
TENIDX		EQU	0X23	;十位查表指標

RES_VECT    CODE    0x0000
    GOTO	START
INT_VECTOR  CODE    0x0004
    GOTO	INTSUB

START:
    CLRF	IDX
    CLRF	ONEIDX
    CLRF	TENIDX
    MOVLB     .17
    MOVLW     0X70
    MOVWF     OSCCON1
    MOVLW	0X04
    MOVWF	OSCFRQ
    MOVLB	.11
    BSF		INTCON,GIE
    BSF		INTCON,PEIE
    MOVLB	.0
    MOVLW	0x80
    MOVWF	T0CON0
    MOVLW	0x47	;設定Timer0預除比為1:128
    MOVWF	T0CON1
    MOVLW	0xE9	;Timer0計數初值
    MOVWF	TMR0H
    MOVLW	0x00
    MOVWF	TMR0L
    MOVLB	.4
    MOVLW	0x31	;Timer1 ON且設定Timer1預除比為1:8
    MOVWF	T1CON 
    MOVLW	0x01
    MOVWF	T1CLK 
    MOVLW	0x6D	;Timer1計數初值
    MOVWF	TMR1H 
    MOVLW	0x84
    MOVWF	TMR1L 
    MOVLB	.0
    MOVLW    B'11111001'
    MOVWF    TRISB
    CLRF	TRISD		;設定PORTD為輸出接腳
    MOVLW	B'11111111'	;LED全亮
    MOVWF	LATD	
    MOVLB	.14
    BCF		PIR0,TMR0IF	;清除Timer0中斷旗標位元
    BSF		PIE0,TMR0IE	;致能Timer0中斷
    BCF		PIR4,TMR1IF	;清除Timer1中斷旗標位元
    BSF		PIE4,TMR1IE	;致能Timer1中斷
    
  
WAIT:		NOP			;等待Timer中斷
    GOTO	WAIT
INTSUB:		

    MOVLB	.14
    BTFSS	PIR0,TMR0IF
    GOTO	T1A
T0A:
     MOVLB	.0
    BTFSC	IDX,0
    GOTO	TENTBL
ONETBL:
    MOVLB	.0
    BSF		LATB,1
    BCF		LATB,2
    MOVF	ONEIDX,W
    CALL	TABLE
    MOVWF	LATD
    COMF	IDX,F
T01:
     MOVLB	.14
    BCF		PIR0,TMR0IF	;清除Timer0中斷旗標位元
    MOVLB	.0
    MOVLW	0xE9	;Timer0計數初值
    MOVWF	TMR0H
    MOVLW	0x00
    MOVWF	TMR0L
    RETFIE
TENTBL:	
    MOVLB	.0
    BCF		LATB,1
    BSF		LATB,2
    MOVF	TENIDX,W
    CALL	TABLE
    MOVWF	LATD
    CLRF	IDX
    GOTO	T01
T1A:
    MOVLB	.4
    DECFSZ	T1CNT,F
    GOTO	T18
T11:
    MOVLB	.4
    MOVLW	.5
    MOVWF	T1CNT
T12:
     MOVLB	.0
    INCF	ONEIDX,F
T13:
    MOVLB	.0
    MOVLW	.10
    SUBWF	ONEIDX,W
    BTFSS	STATUS,Z
    GOTO	T18
T14:
    MOVLB	.0
    CLRF	ONEIDX
T15:
    MOVLB	.0
    INCF	TENIDX,F
T16:
    MOVLB	.0
    MOVLW	.10
    SUBWF	TENIDX,W
    BTFSS	STATUS,Z
    GOTO	T18
T17:
    MOVLB	.0
    CLRF	TENIDX
T18:
    MOVLB	.14
    BCF		PIR4,TMR1IF	;清除Timer1中斷旗標位元
    MOVLB	.4
    MOVLW	0x6D	;Timer1計數初值
    MOVWF	TMR1H 
    MOVLW	0x84
    MOVWF	TMR1L 
    RETFIE

TABLE:		ADDWF	PCL,F
    RETLW	B'00111111'	;0
    RETLW	B'00000110'	;1
    RETLW	B'01011011'	;2
    RETLW	B'01001111'	;3
    RETLW	B'01100110'	;4
    RETLW	B'01101101'	;5
    RETLW	B'01111101'	;6
    RETLW	B'00100111'	;7
    RETLW	B'01111111'	;8
    RETLW	B'01101111'	;9
		END		