﻿#include "p16f18877.inc"
__CONFIG _CONFIG1, _FEXTOSC_HS & _RSTOSC_EXT1X
__CONFIG _CONFIG2, _BOREN_ON & _PPS1WAY_OFF
__CONFIG _CONFIG3, _WDTE_OFF 
__CONFIG _CONFIG5, _CP_OFF & _CPD_OFF
    
D1		EQU	0X20
D2		EQU	0X21
D3		EQU	0X22
DATA_TEMP	EQU	0X23
		
RES_VECT    CODE    0x0000
    GOTO	START

START:
    MOVLB     .17
    MOVLW     0X70
    MOVWF     OSCCON1
    MOVLW	0X04
    MOVWF	OSCFRQ
    MOVLB     .1
    MOVLW	0x3F
    MOVWF	ADCLK 
    MOVLW	0x80
    MOVWF	ADCON0	     ;設定AD轉換值的格式為向左靠
    MOVLB	.0
    CLRF	TRISD		;設定PORTD為輸出接腳
    CLRF	LATD
    MOVLB     .14
    BCF		PIR1,ADIF	;清除ADC中斷旗標位元
    BSF		STATUS,C	;設定進位旗標為1
RL:		
    MOVLB	.0
    RLF		LATD ,F		;LED燈號向左移位
    CALL	ADCONVERT		
    CALL	DELAY
    MOVLB	.0
    BTFSS 	LATD,7		;檢查PORTD<7>的狀態，若為邏輯1則跳過一行指令
				;若為邏輯0則不合跳躍條件，直接執行下一行指令
    GOTO	RL				
RR:		
    MOVLB	.0
    RRF		LATD ,F		;LED燈號向右移位
    CALL	ADCONVERT		
    CALL	DELAY
    MOVLB	.0
    BTFSS 	LATD,0		;檢查PORTD<0>的狀態，若為邏輯1則跳過一行指令
				;若為邏輯0則不合跳躍條件，直接執行下一行指令
    GOTO	RR		
    GOTO	RL			

ADCONVERT:
    MOVLB	.1
    MOVLW	0X03
    MOVWF    ADPCH
    BSF		ADCON0,ADON
    BCF		ADCON0,ADCONT
    BSF		ADCON0,ADGO
ADWAIT:
    MOVLB     .14
    BTFSS	PIR1,ADIF
    GOTO	ADWAIT
    BCF		PIR1,ADIF	;清除ADC中斷旗標位元
    MOVLB     .1
    MOVF	ADRESH,W	;把ADRESH的內容放入W暫存器
    BTFSS	STATUS,Z	;檢查零旗標是否為1
    GOTO	AA		;否,跳到AA執行
    MOVLB     .1
    MOVLW	0x04	    ;是,ADRESH為1
    MOVWF	ADRESL	    ;(ADRESH ADRESL) << 6 
    MOVLW	0x00	    ;(00000000 00000010) << 6
    MOVWF	ADRESH	    ; 00000001 00000000
AA:
    MOVLB     .1
    MOVF	ADRESH,W	;把ADRESH的內容放入W暫存器
    MOVLB     .0
    MOVWF	DATA_TEMP	;把W暫存器的內容放入DATA_TEMP暫存器
    
DELAY:		
    MOVLB     .0
    MOVF	DATA_TEMP,W	;延遲副程式
    MOVWF	D3
DLY1:		
    MOVLW	.5
    MOVWF	D2
DLY2:		
    DECFSZ	D1,F
    GOTO	DLY2
    DECFSZ	D2,F
    GOTO	DLY2
    DECFSZ	D3,F
    GOTO	DLY1
    RETURN

DELAY1:	        
    MOVLB     .0
    MOVLW	.24
    MOVWF	D1			
DLY11:		
    DECFSZ	D1,F
    GOTO	DLY11
    RETURN			
    END