#include "p16f18877.inc"
__CONFIG _CONFIG1, _FEXTOSC_HS & _RSTOSC_EXT1X
__CONFIG _CONFIG2, _BOREN_ON & _PPS1WAY_OFF
__CONFIG _CONFIG3, _WDTE_OFF 
__CONFIG _CONFIG5, _CP_OFF & _CPD_OFF
VALUEL          EQU     0x320
VALUEH          EQU     0x321
RES_VECT    CODE    0x0000
    GOTO	START
INT_VECTOR  CODE    0x0004
    GOTO	INTSUB
    
START:
    MOVLB     .17
    MOVLW	0X70
    MOVWF	OSCCON1
    MOVLW	0X04
    MOVWF	OSCFRQ
    
    MOVLB	.0
    CLRF TRISB
    
    MOVLW 0XFB
    MOVWF TRISC
    CLRF	TRISD
    MOVLW 0X10
    MOVWF LATB
    MOVLW 0XFF
    MOVWF LATD
    MOVLB	.62
    MOVLW 0XFD
    MOVWF ANSELA
    MOVLB	.0
    MOVLW 0XFF
    MOVWF TRISA
    BSF		INTCON,GIE
    BSF		INTCON,PEIE
    
    MOVLB	.4
    MOVLW	0x01
    MOVWF	T1CLK 
    MOVLW	0x31
    MOVWF	T1CON 
    MOVLB     .6
    MOVLW	0x85
    MOVWF	CCP5CON     
    MOVLW	0x00
    MOVWF	CCPR5L   
    MOVLW	0x00
    MOVWF	CCPR5H 
    MOVLB     .4
    MOVLW	0x01
    MOVWF	CCPTMRS1
    MOVLB     .14
    BCF		PIR6,4
    BSF		PIE6,4
    MOVLB     .61
    MOVLW	0x01
    MOVWF	CCP5PPS
    MOVLB     .5
    MOVLW	0x01
    MOVWF   T2CLKCON
    MOVLW	0x00
    MOVWF   T2HLT
    MOVLW	0x00
    MOVWF   T2RST
    MOVLW	0xFF
    MOVWF   T2PR
    MOVLW	0x00
    MOVWF   T2TMR
    MOVLB     .14
    BCF PIR4,1
    MOVLB     .5
    MOVLW	0x80
    MOVWF   T2CON
    
    MOVLB     .6
    MOVLW	0x8F
    MOVWF   CCP1CON

    MOVLB     .4
    BSF		CCPTMRS0,0
    MOVLB     .62
    MOVLW	0x09
    MOVWF	RC2PPS
    
    MOVLB     .1
    MOVLW	0x3F
    MOVWF	ADCLK
    MOVLW	0x80
    MOVWF    ADCON0
    
WAIT:		
    MOVLB     .1
    BSF		ADCON0,0
ADCWAIT:
    BTFSC	ADCON0,0
    GOTO	ADCWAIT
    MOVFW	ADRESH
    MOVLB     .6
    MOVWF	CCPR1H
 
    GOTO	WAIT
INTSUB:		
    MOVLB	.14
    BCF		PIR6,4		;清除CCP中斷旗標位元
    MOVLB .6
    MOVF    CCPR5L,W
    MOVWF   VALUEL 
    MOVF    CCPR5H,W
    MOVWF   VALUEH
   
    
CHKDATA:
    
    MOVLB .6
    MOVLW   0x0DC
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x005
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C1         ;C=1: >= 1500
;               ;                       ;C=0: <  1500
    
    MOVLB .6
    MOVLW   0x078
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x005
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C2         ;C=1: >= 1400
;               ;                       ;C=0: <  1400
    
    MOVLB .6
    MOVLW   0x014
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x005
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C3        ;C=1: >= 1300
;               ;                       ;C=0: <  1300
    
    MOVLB .6
    MOVLW   0x0E8
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x003
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C4        ;C=1: >= 1000
;               ;                       ;C=0: <  1000
    
    MOVLB .6
    MOVLW   0x052
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x003
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C5         ;C=1: >= 0850
;               ;                       ;C=0: <  0850
  
    MOVLB .6
    MOVLW   0x020
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x003
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C6         ;C=1: >= 0800
;               ;                       ;C=0: <  0800
    
    MOVLB .6
    MOVLW   0x0F8
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x002
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C7         ;C=1: >= 0760
;               ;                       ;C=0: <  0760
    
    MOVLB .6
    MOVLW   0x0D0
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x002
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C8         ;C=1: >= 0720
;               ;                       ;C=0: <  0720
    
    MOVLB .6
    MOVLW   0x0BC
    SUBWF   VALUEL,W        ;比較 (VALUEL) - (W)
    MOVLW   0x002
    SUBWFB  VALUEH,W        ;比較 (VALUEH) - (W)
    BTFSC   STATUS,C        ;CHK C=1:(>=)夠減   C=0:(<)不夠減
    GOTO    C9         ;C=1: >= 0700
               ;                       ;C=0: <  0700
C1:
    MOVLB .0
    MOVLW   B'00000110'
    MOVWF   LATD            ;SET LATD = 0b00000110 for >= 1500[05DC]
    GOTO RETDATA
C2:
    MOVLB .0
    MOVLW   B'01011011'
    MOVWF   LATD            ;SET LATD = 0b01011011 for >= 1400[0578]
    GOTO RETDATA
C3:
    MOVLB .0
    MOVLW   B'00011111'
    MOVWF   LATD            ;SET LATD = 0b00011111 for >= 1300[0514]
    GOTO RETDATA
C4:
    MOVLB .0
    MOVLW   B'01100110'
    MOVWF   LATD            ;SET LATD = 0b01100110 for >= 1000[03E8]
    GOTO RETDATA
C5:
    MOVLB .0
    MOVLW   B'01101101'
    MOVWF   LATD            ;SET LATD = 0b01101101 for >= 0850[0352]
    GOTO RETDATA
C6:
    MOVLB .0
    MOVLW   B'01111101'
    MOVWF   LATD            ;SET LATD = 0b01111101 for >= 0800[0320]
    GOTO RETDATA
C7:
    MOVLB .0
    MOVLW   B'00000111'
    MOVWF   LATD            ;SET LATD = 0b00000111 for >= 0760[02F8]
    GOTO RETDATA
C8:
    MOVLB .0
    MOVLW   B'11111111'
    MOVWF   LATD            ;SET LATD = 0b11111111 for >= 0720[02D0]
    GOTO RETDATA
C9:
    MOVLB .0
    MOVLW   B'11101111'
    MOVWF   LATD            ;SET LATD = 0b11101111 for >= 0700[02BC]
    GOTO RETDATA
RETDATA:
    MOVLB .4
    CLRF TMR1H
    CLRF TMR1L
    RETFIE
    END