#include <pic16f18877.h>
#include <stdint.h>
#include <stdbool.h>

#pragma config FEXTOSC = HS     // External Oscillator mode selection bits (HS (crystal oscillator) above 4MHz; PFM set to high power)
#pragma config RSTOSC = EXT1X    // Power-up default value for COSC bits->EXTOSC operating per FEXTOSC bits
#pragma config BOREN = ON       // Brown-out reset enable bits (Brown-out Reset Enabled, SBOREN bit is ignored)
#pragma config WDTE = OFF       // WDT operating mode (WDT Disabled, SWDTEN is ignored)
#pragma config CP = OFF         // UserNVM Program memory code protection bit (Program Memory code protection disabled)
#pragma config CPD = OFF        // DataNVM code protection bit (Data EEPROM code protection disabled)

void Initialize(void);
void Delay_x_mS(int N_mS);
uint16_t count;

void main(void) {
    Initialize();

    while (1) {
        for (count = 0; count <= 30; count++) {
            DAC1CON1 = count;
            Delay_x_mS(500);
        }
    }

    return;
}

void Initialize(void) {
    OSCCON1 = 0x70;
    OSCFRQ = 0x04;

    TRISA = 0xFB;

    // DAC1EN enabled; NSS VSS; PSS VDD; OE1 enabled; OE2 disabled; 
    DAC1CON0 = 0xA0;
    DAC1CON1 = 0x00;
}

void Delay_x_mS(int N_mS) //Ƶ{ (۳]ܼ)
{
    int Loop_mS, Del_1mS; //۳]ܼ

    for (Loop_mS = 0; Loop_mS < N_mS; Loop_mS++)//(l;;B⦡) 
    {
        for (Del_1mS = 0; Del_1mS < 199; Del_1mS++);
    }
}